# ULOHA 1 - KEPLEROVA ROVNICE

from math import*   # zpristupni modul s matematickymi funkcemi a konstantami

# ZADANI
AU = 149597870691   # astronomical unit
a = 5.2033 * AU     # hlavni polosa drahy
e = 0.0484          # numericka excentricita drahy
k = 8               # konstsanta pro vypocet M
M = 8*k *pi/180     # stredni anomalie v radianech
def f(E):                         # resena Keplerova rovnice
    return M + e*sin(E) - E
def r(E):                         # vypocet pruvodice planety
    return a * ( 1 - e*cos(E) )

# derivace f
def f1(E):                         # 1 derivace Keplerovi rovnice
    return e*cos(E) - 1
def f2(E):                         # 2 derivace Keplerovi rovnice
    return -e*sin(E)

################################################################################
print '1. METODA PULENI INTERVALU'
A = 1               # dolni mez intervalu ( f(A) > 0 )
B = 2               # horni mez intervalu ( f(B) < 0 )
i = 0               # pocet potrebnych iteraci

while 1:
    E = 0.5 * (A+B)       # vzorec metody
    if f(A) * f(E) > 0:
        A = E             # Pokud f(A) i f(E) maji stejne znamenko
    else:
        B = E
    i += 1             # nacitani iteraci
    if abs( f(E) ) < 10**-16:
        break   # ukonceni cylku (obdoba do...while)

print 'E = ', E
print 'f(E) = ', f(E)
print 'iteraci: ', i

################################################################################
print '\n2. METODA SECEN'
E = 1               # dolni mez intervalu (rovnou voleno jako 1.priblizeni)
B = 2               # horni mez intervalu
i = 0               # pocet potrebnych iteraci

while 1:
    E = E - ( (B-E)/(f(B)-f(E)) ) * f(E)  # vzorec metody
    i += 1
    if abs( f(E) ) < 10**-16:
        break   # ukonceni cylku (obdoba do...while)

print 'E = ', E
print 'f(E) = ', f(E)
print 'iteraci: ', i

################################################################################
print '\n3. METODA TECEN'
E = 1               # dolni mez intervalu (rovnou voleno jako 1.priblizeni)
B = 2               # horni mez intervalu
i = 0               # pocet potrebnych iteraci

while 1:
    E = E - ( f(E)/f1(E) )       # vzorec metody
    i += 1
    if abs( f(E) ) < 10**-16:
        break   # ukonceni cylku (obdoba do...while)

print 'E = ', E
print 'f(E) = ', f(E)
print 'iteraci: ', i

################################################################################
print '\n4. ITERACNI METODA 3. RADU'
E = 1               # dolni mez intervalu (rovnou voleno jako 1.priblizeni)
B = 2               # horni mez intervalu
i = 0               # pocet potrebnych iteraci

while 1:
    E = E-( f(E)/f1(E) ) -0.5*( f2(E)*f(E)*f(E) )/( f1(E)**3)   # vzorec metody
    i += 1
    if abs( f(E) ) < 10**-16:
        break   # ukonceni cylku (obdoba do...while)

print 'E = ', E
print 'f(E) = ', f(E)
print 'iteraci: ', i

print '\nE ve stupnich:   E = ', E*180/pi
print 'Delka pruvodice: r = ', r(E)/AU
